import {system, world, ItemStack, System, MinecraftDimensionTypes} from "@minecraft/server";
import { Enchantments } from "classes/Enchantments.js";

//------------------------------------------------
//Adjust Values Here
let amethystNeedAmount = 1;
let DisenchantTimeTicks = 20; // 20 ticks = 1 second/s
//------------------------------------------------

/*
system.beforeEvents.watchdogTerminate.subscribe((eventData)=>{
	eventData.cancel = true;
});
*/

world.afterEvents.worldInitialize.subscribe(()=>{
	system.runTimeout(()=>{
		world.sendMessage(`[DisEnchanter] Addon is Active.`)
		console.warn(`[DisEnchanter] Addon is Active.`)
		DisEnchanterMain()
	},60)
})

world.afterEvents.playerPlaceBlock.subscribe(({block})=>{
	const blockID = block.typeId
	if(blockID != "disenchanter:disenchanting_table_block") return true
	let {x,y,z} = block.location
	const blockDimension = block.dimension
	x = x+0.5
	z = z+0.5

	const disenchantingEntity = blockDimension.spawnEntity("disenchanter:disenchanting_table", {x,y,z})
	const disenchantSlot0 = blockDimension.spawnEntity("disenchanter:slot", {x,y,z:z-0.03})	
	const disenchantSlot1 = blockDimension.spawnEntity("disenchanter:slot", {x:x+0.3,y,z:z-0.03})	
	const disenchantSlot8 = blockDimension.spawnEntity("disenchanter:slot", {x:x+0.2,y,z:z-0.2})	
	const disenchantSlot7 = blockDimension.spawnEntity("disenchanter:slot", {x,y,z:z-0.3})	
	const disenchantSlot6 = blockDimension.spawnEntity("disenchanter:slot", {x:x-0.2,y,z:z-0.2})	
	const disenchantSlot5 = blockDimension.spawnEntity("disenchanter:slot", {x:x-0.3,y,z:z-0.03})	
	const disenchantSlot4 = blockDimension.spawnEntity("disenchanter:slot", {x:x-0.2,y,z:z+0.15})	
	const disenchantSlot3 = blockDimension.spawnEntity("disenchanter:slot", {x,y,z:z+0.25})	
	const disenchantSlot2 = blockDimension.spawnEntity("disenchanter:slot", {x:x+0.2,y,z:z+0.15})
	
	//Prevent renaming disenchanter entities
	const intervals = [1,3,5]
	intervals.forEach((interval)=>{
		system.runTimeout(()=>{
			disenchantingEntity.nameTag = `§r§r§rdisenchanting Table`
			disenchantSlot0.nameTag = `s0`
			disenchantSlot1.nameTag = `s1`
			disenchantSlot8.nameTag = `s8`
			disenchantSlot7.nameTag = `s7`
			disenchantSlot6.nameTag = `s6`
			disenchantSlot5.nameTag = `s5`
			disenchantSlot4.nameTag = `s4`
			disenchantSlot3.nameTag = `s3`
			disenchantSlot2.nameTag = `s2`
		},interval)
	})
})

function DisEnchanterMain(){
	system.runInterval(function Disenchanting(){
		let queryTable = {type:"disenchanter:disenchanting_table",excludeTags:["disenchanting"]};
		let getDisenchantingTables = world.getDimension(`overworld`).getEntities(queryTable);
		for(let table of getDisenchantingTables){
					
			let container = table.getComponent('inventory').container;

			//////////////////////////////////////
			//Remove Excess Items
			//Remove Non-Book Items
			//Remove Non-Amethyst Item
			//////////////////////////////////////
			for(let slotIndex=0; slotIndex<=9; slotIndex++){
				let item = container.getItem(slotIndex);
				if(!item) continue;
				if(slotIndex >= 0 && slotIndex <=8 && item.amount>1){
					item.amount = item.amount-1
					table.dimension.spawnItem(item,table.location);
					item.amount = 1
					container.setItem(slotIndex,item);
				}
				if(slotIndex >= 1 && slotIndex <=8 && item.typeId != "minecraft:book" && item.typeId != "minecraft:enchanted_book"){
					table.dimension.spawnItem(item,table.location);
					container.setItem(slotIndex,undefined);
				}
				if(slotIndex == 9 && item.typeId != "minecraft:amethyst_shard"){
					table.dimension.spawnItem(item,table.location);
					container.setItem(slotIndex,undefined);
				}
			}
			
			//////////////////////////////////////
			//Display Floating Items
			//////////////////////////////////////			
			let queryTableSlots = {type:"disenchanter:slot",location:table.location,maxDistance:1,closest:9};
			let getTableSlots = table.dimension.getEntities(queryTableSlots);	
			for(let slotIndex=0; slotIndex<=8; slotIndex++){
				for(let slot of getTableSlots){
					if(!slot.nameTag.includes(slotIndex)) continue;
					let tableSlotItem = container.getItem(slotIndex);
					if(!tableSlotItem) {
						slot.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 air`);
						continue;
					}
					switch(tableSlotItem.typeId){
						case "minecraft:shield":
							slot.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 disenchanter:shield_item`);
							break;
						case "minecraft:trident":
							slot.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 disenchanter:trident_item`);
							break;
						case "minecraft:crossbow":
							slot.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 disenchanter:crossbow_item`);
							break;
						case "minecraft:bow":
							slot.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 disenchanter:bow_item`);
							break;
						default:
							slot.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 ${tableSlotItem.typeId}`);
					}				
					if(Enchantments.getEnchants(tableSlotItem).length){							
						slot.runCommandAsync(`enchant @s sharpness 1`)
						slot.runCommandAsync(`enchant @s protection 1`)
						slot.runCommandAsync(`enchant @s loyalty 1`)
						slot.runCommandAsync(`enchant @s unbreaking 1`)		
					}
					//if(!slot.getComponent('inventory').container.getItem(slotSize)) continue;
					//slot.runCommandAsync(`say ${slot.getComponent('inventory').container.getItem(slotSize).typeId}`);				
				}						
			}
	
			//////////////////////////////////////
			//Disenchanting Items
			//////////////////////////////////////
	
			if(!hasNecessaryItems(container)) continue;
			table.addTag("disenchanting");
			
			let scheduleId = system.runInterval(function Disenchanting(){
				if(!hasNecessaryItems(container)) {
					table.removeTag("disenchanting");
					system.clearRun(scheduleId);				
					return;
				}
				let location = {x:table.location.x,y:table.location.y,z:table.location.z};
				let getEnchantedItem = container.getItem(0);
				let getEnchants = Enchantments.getEnchants(getEnchantedItem);
				
				for(let slotIndex=1; 8>=slotIndex; slotIndex++){				
					let book = container.getItem(slotIndex);
					if(!book) continue;
					if(book.typeId != "minecraft:book") continue;
					if(Enchantments.getEnchants(book).length != 0) continue;
					if(getEnchants.length <= 0) break;
					let newBook = Enchantments.addEnchant(new ItemStack('minecraft:enchanted_book'),getEnchants[0]);
					let newEnchantedItem = Enchantments.removeEnchant(getEnchantedItem,getEnchants[0]);
					container.setItem(slotIndex,newBook);
					
					if(Enchantments.getEnchants(newEnchantedItem).length == 0 && getEnchantedItem.typeId == 'minecraft:enchanted_book'){
						container.setItem(0,new ItemStack('minecraft:book',1));
					}else{
						container.setItem(0,newEnchantedItem);
					}
					break;
				}
				
				let amethystItem = container.getItem(9);
				let amethystCurrentAmount = amethystItem.amount;
				
				if(amethystCurrentAmount-amethystNeedAmount>0){
					container.setItem(9, new ItemStack(amethystItem.typeId,amethystCurrentAmount-amethystNeedAmount));
				}else{
					container.setItem(9, undefined);	
				}
				
				playDisenchantSound(location);
				table.removeTag("disenchanting");
				system.clearRun(scheduleId);
			},DisenchantTimeTicks);
		}	
	},10);
}


function hasNecessaryItems(container){
	let enchantedItems = 0;
	let books = 0;
	let amethyst = 0;
	
	for(let slotIndex=1; 8>=slotIndex; slotIndex++){	
		let item = container.getItem(slotIndex);
		if(!item) continue;	
		if(item.typeId == "minecraft:book") books++;						
	}
	let getAmethystShardItem = container.getItem(9);
	let getEnchantedItem = container.getItem(0);
	if(!getEnchantedItem) return false;
	if(!getAmethystShardItem) return false;
	if(Enchantments.getEnchants(getEnchantedItem).length > 0) enchantedItems++;	
	if(getAmethystShardItem.typeId == "minecraft:amethyst_shard") amethyst = getAmethystShardItem.amount;	
	if(amethyst < amethystNeedAmount || books == 0 || enchantedItems == 0) return false;
	return true;
}

function playDisenchantSound(location){
	let queryPlayer = {families:["player"],location:location,maxDistance:3};
	let getNearestPlayers = world.getDimension('overworld').getEntities(queryPlayer);
	for(let player of getNearestPlayers){
		player.playSound("block.enchanting_table.use");
	}
}